********************************************************************************
* FBA_CoreTextbookModel.gms
* Joshua J. Hamilton, Joohnoon Kim, and Jennifer L. Reed
* Department of Chemical and Biological Engineering
* University of Wisconsin-Madison, Madison, Wisconsin, USA
* http://reedlab.che.wisc.edu/
*
* Computational Tools for Analyzing Microbial Metabolism Workshop
* American Society of Microbiology 2013 Annual Meeting
* Denver, Colorado, USA
* May 18, 2013
* This workshop was supported in part by an NSF CAREER Award to J. Reed
* (NSF 1053712) and an NSF Graduate Research Fellowship to J. Hamilton
* (DGE-0718123).
********************************************************************************

$offlisting
$offdigit
Set j reactions in S (n)
/ Biomass,ATPM,EX_ac_e,EX_akg_e,EX_co2_e,EX_etoh_e,EX_for_e,EX_fum_e,EX_glc_e,
  EX_h_e,EX_h2o_e,EX_lacD_e,EX_o2_e,EX_pi_e,EX_pyr_e,EX_succ_e
  PGI,PFK,FBA,FBP,TPI,GAPD,PGK,PGM,ENO,PYK,PPS,PDH
  CS,ACONT,ICDHyr,AKGDH,SUCOAS,SUCD1i,SUCD4,FRD,FUM,MDH,ICL,MALS
  G6PDH2r,PGL,GND,RPE,RPI,TALA,TKT1,TKT2,
  PFL,PTAr,ACKr,ADHEr,LDH_D,ME1,ME2,PPC,PPCK,
  ACt2r,AKGt2r,CO2t,DLACt2,ETOHt2r,FORt,FUMt2_2,GLCpts,H2Ot,O2t,PIt,PYRt2r,SUCCt2_2,SUCCt2b
  ATPS4r,CYTBD,NADH11,NADTRHD,THD2,ADK1
/;

Set i metabolites in S (m)
/ 13dpg,2pg,3pg,6pgc,6pgl,ac,accoa,actp,adp,akg,amp,atp,cit
  co2,coa,dhap,e4p,etoh,f6p,fad,fadh2,fdp,formate,fumarate,g3p,g6p
  glx,h,h2o,icit,lacD,malL,nad,nadh,nadp,nadph,o2,oaa,pep
  pi,pyr,q8,q8h2,r5p,ru5pD,s7p,succ,succoa,xu5pD,ac_e,akg_e,co2_e
  etoh_e,formate_e,fumarate_e,glcD_e,h_e,h2o_e,lacD_e,o2_e,pi_e,pyr_e,succ_e
/;

Set rev(j) subset of reactions which are reversible
/ ACKr,ACONT,ACt2r,ADHEr,ADK1,AKGt2r,ATPS4r,CO2t,DLACt2,ENO,ETOHt2r,FBA,FORt,
  FUM,G6PDH2r,GAPD,H2Ot,ICDHyr,LDH_D,MDH,O2t,PGI,PGK,PGM,PIt,PTAr,PYRt2r,RPE,
  RPI,SUCD4,SUCOAS,TALA,TKT1,TKT2,TPI
/;

Set exch(j) subset of reactions which are exchange reactions
/ EX_ac_e,EX_akg_e,EX_co2_e,EX_etoh_e,EX_for_e,EX_fum_e,EX_glc_e,EX_h2o_e,
  EX_h_e,EX_lacD_e,EX_o2_e,EX_pi_e,EX_pyr_e,EX_succ_e
/;

Parameters
    Vmax /1000/
    UpperLimits(j) maximum value flux can take
    LowerLimits(j) minimum value flux can take
;

Parameter S(i,j) contains the S matrix
/
ac_e.EX_ac_e    -1.000000
akg_e.EX_akg_e  -1.000000
co2_e.EX_co2_e  -1.000000
etoh_e.EX_etoh_e        -1.000000
formate_e.EX_for_e      -1.000000
fumarate_e.EX_fum_e     -1.000000
glcD_e.EX_glc_e        -1.000000
h_e.EX_h_e      -1.000000
h2o_e.EX_h2o_e  -1.000000
lacD_e.EX_lacD_e        -1.000000
o2_e.EX_o2_e    -1.000000
pi_e.EX_pi_e    -1.000000
pyr_e.EX_pyr_e  -1.000000
succ_e.EX_succ_e        -1.000000
ac.ACKr        -1.000000
actp.ACKr       1.000000
adp.ACKr        1.000000
atp.ACKr        -1.000000
cit.ACONT       -1.000000
icit.ACONT      1.000000
ac.ACt2r        1.000000
h.ACt2r        1.000000
ac_e.ACt2r      -1.000000
h_e.ACt2r       -1.000000
accoa.ADHEr     -1.000000
coa.ADHEr       1.000000
etoh.ADHEr      1.000000
h.ADHEr        -2.000000
nad.ADHEr       2.000000
nadh.ADHEr      -2.000000
adp.ADK1        2.000000
amp.ADK1        -1.000000
atp.ADK1        -1.000000
akg.AKGt2r      1.000000
h.AKGt2r        1.000000
akg_e.AKGt2r    -1.000000
h_e.AKGt2r      -1.000000
adp.ATPM        1.000000
atp.ATPM        -1.000000
h.ATPM  1.000000
h2o.ATPM        -1.000000
pi.ATPM        1.000000
adp.ATPS4r      -1.000000
atp.ATPS4r      1.000000
h.ATPS4r        3.000000
h2o.ATPS4r      1.000000
pi.ATPS4r       -1.000000
h_e.ATPS4r      -4.000000
3pg.Biomass     -1.496000
accoa.Biomass   -3.747800
adp.Biomass     42.703000
akg.Biomass     -1.078900
atp.Biomass     -42.703000
coa.Biomass     3.747800
e4p.Biomass     -0.361000
f6p.Biomass     -0.070900
g3p.Biomass     -0.129000
g6p.Biomass     -0.205000
h.Biomass       28.025000
h2o.Biomass     -42.703000
nad.Biomass     -3.547000
nadh.Biomass    3.547000
nadp.Biomass    18.225000
nadph.Biomass   -18.225000
oaa.Biomass     -1.786700
pep.Biomass     -0.519100
pi.Biomass      42.703000
pyr.Biomass     -2.832800
r5p.Biomass     -0.897700
co2.CO2t        1.000000
co2_e.CO2t      -1.000000
accoa.CS        -1.000000
cit.CS  1.000000
coa.CS  1.000000
h.CS    1.000000
h2o.CS  -1.000000
oaa.CS  -1.000000
h.CYTBD        -2.000000
h2o.CYTBD       1.000000
o2.CYTBD        -0.500000
q8.CYTBD        1.000000
q8h2.CYTBD      -1.000000
h_e.CYTBD       2.000000
h.DLACt2        1.000000
lacD.DLACt2     1.000000
h_e.DLACt2      -1.000000
lacD_e.DLACt2   -1.000000
2pg.ENO        -1.000000
h2o.ENO        1.000000
pep.ENO        1.000000
etoh.ETOHt2r    1.000000
h.ETOHt2r       1.000000
etoh_e.ETOHt2r  -1.000000
h_e.ETOHt2r     -1.000000
dhap.FBA        1.000000
fdp.FBA        -1.000000
g3p.FBA        1.000000
f6p.FBP        1.000000
fdp.FBP        -1.000000
h2o.FBP        -1.000000
pi.FBP  1.000000
formate.FORt    1.000000
formate_e.FORt  -1.000000
fad.FRD        1.000000
fadh2.FRD       -1.000000
fumarate.FRD    -1.000000
succ.FRD        1.000000
fumarate.FUM    -1.000000
h2o.FUM        -1.000000
malL.FUM        1.000000
fumarate.FUMt2_2        1.000000
h.FUMt2_2       2.000000
fumarate_e.FUMt2_2      -1.000000
h_e.FUMt2_2     -2.000000
6pgl.G6PDH2r    1.000000
g6p.G6PDH2r     -1.000000
h.G6PDH2r       1.000000
nadp.G6PDH2r    -1.000000
nadph.G6PDH2r   1.000000
13dpg.GAPD      1.000000
g3p.GAPD        -1.000000
h.GAPD  1.000000
nad.GAPD        -1.000000
nadh.GAPD       1.000000
pi.GAPD        -1.000000
g6p.GLCpts      1.000000
pep.GLCpts      -1.000000
pyr.GLCpts      1.000000
glcD_e.GLCpts   -1.000000
6pgc.GND        -1.000000
co2.GND        1.000000
nadp.GND        -1.000000
nadph.GND       1.000000
ru5pD.GND       1.000000
h2o.H2Ot        1.000000
h2o_e.H2Ot      -1.000000
akg.ICDHyr      1.000000
co2.ICDHyr      1.000000
icit.ICDHyr     -1.000000
nadp.ICDHyr     -1.000000
nadph.ICDHyr    1.000000
glx.ICL        1.000000
icit.ICL        -1.000000
succ.ICL        1.000000
h.LDH_D        1.000000
lacD.LDH_D      -1.000000
nad.LDH_D       -1.000000
nadh.LDH_D      1.000000
pyr.LDH_D       1.000000
accoa.MALS      -1.000000
coa.MALS        1.000000
glx.MALS        -1.000000
h.MALS  1.000000
h2o.MALS        -1.000000
malL.MALS       1.000000
h.MDH   1.000000
malL.MDH        -1.000000
nad.MDH        -1.000000
nadh.MDH        1.000000
oaa.MDH        1.000000
co2.ME1        1.000000
malL.ME1        -1.000000
nad.ME1        -1.000000
nadh.ME1        1.000000
pyr.ME1        1.000000
co2.ME2        1.000000
malL.ME2        -1.000000
nadp.ME2        -1.000000
nadph.ME2       1.000000
pyr.ME2        1.000000
h.NADH11        -3.000000
nad.NADH11      1.000000
nadh.NADH11     -1.000000
q8.NADH11       -1.000000
q8h2.NADH11     1.000000
h_e.NADH11      2.000000
o2.O2t  1.000000
o2_e.O2t        -1.000000
accoa.PDH       1.000000
co2.PDH        1.000000
coa.PDH        -1.000000
nad.PDH        -1.000000
nadh.PDH        1.000000
pyr.PDH        -1.000000
adp.PFK        1.000000
atp.PFK        -1.000000
f6p.PFK        -1.000000
fdp.PFK        1.000000
h.PFK   1.000000
accoa.PFL       1.000000
coa.PFL        -1.000000
formate.PFL     1.000000
pyr.PFL        -1.000000
f6p.PGI        1.000000
g6p.PGI        -1.000000
13dpg.PGK       1.000000
3pg.PGK        -1.000000
adp.PGK        1.000000
atp.PGK        -1.000000
6pgc.PGL        1.000000
6pgl.PGL        -1.000000
h.PGL   1.000000
h2o.PGL        -1.000000
2pg.PGM        -1.000000
3pg.PGM        1.000000
pi.PIt  -1.000000
pi_e.PIt        1.000000
co2.PPC        -1.000000
h.PPC   1.000000
h2o.PPC        -1.000000
oaa.PPC        1.000000
pep.PPC        -1.000000
pi.PPC  1.000000
adp.PPCK        1.000000
atp.PPCK        -1.000000
co2.PPCK        1.000000
oaa.PPCK        -1.000000
pep.PPCK        1.000000
amp.PPS        1.000000
atp.PPS        -1.000000
h.PPS   2.000000
h2o.PPS        -1.000000
pep.PPS        1.000000
pi.PPS  1.000000
pyr.PPS        -1.000000
accoa.PTAr      -1.000000
actp.PTAr       1.000000
coa.PTAr        1.000000
pi.PTAr        -1.000000
adp.PYK        -1.000000
atp.PYK        1.000000
h.PYK   -1.000000
pep.PYK        -1.000000
pyr.PYK        1.000000
h.PYRt2r        1.000000
pyr.PYRt2r      1.000000
h_e.PYRt2r      -1.000000
pyr_e.PYRt2r    -1.000000
ru5pD.RPE       -1.000000
xu5pD.RPE       1.000000
r5p.RPI        -1.000000
ru5pD.RPI       1.000000
h.SUCCt2_2      2.000000
succ.SUCCt2_2   1.000000
h_e.SUCCt2_2    -2.000000
succ_e.SUCCt2_2        -1.000000
h.SUCCt2b       -1.000000
succ.SUCCt2b    -1.000000
h_e.SUCCt2b     1.000000
succ_e.SUCCt2b  1.000000
fad.SUCD1i      -1.000000
fadh2.SUCD1i    1.000000
fumarate.SUCD1i        1.000000
succ.SUCD1i     -1.000000
fad.SUCD4       1.000000
fadh2.SUCD4     -1.000000
q8.SUCD4        -1.000000
q8h2.SUCD4      1.000000
adp.SUCOAS      1.000000
atp.SUCOAS      -1.000000
coa.SUCOAS      -1.000000
pi.SUCOAS       1.000000
succ.SUCOAS     -1.000000
succoa.SUCOAS   1.000000
e4p.TALA        1.000000
f6p.TALA        1.000000
g3p.TALA        -1.000000
s7p.TALA        -1.000000
akg.AKGDH       -1.000000
co2.AKGDH       1.000000
coa.AKGDH       -1.000000
nad.AKGDH       -1.000000
nadh.AKGDH      1.000000
succoa.AKGDH    1.000000
nad.NADTRHD     -1.000000
nadh.NADTRHD    1.000000
nadp.NADTRHD    1.000000
nadph.NADTRHD   -1.000000
h.THD2  2.000000
nad.THD2        1.000000
nadh.THD2       -1.000000
nadp.THD2       -1.000000
nadph.THD2      1.000000
h_e.THD2        -2.000000
g3p.TKT1        1.000000
r5p.TKT1        -1.000000
s7p.TKT1        1.000000
xu5pD.TKT1      -1.000000
e4p.TKT2        -1.000000
f6p.TKT2        1.000000
g3p.TKT2        1.000000
xu5pD.TKT2      -1.000000
dhap.TPI        -1.000000
g3p.TPI        1.000000
/;

LowerLimits(j) = 0;
LowerLimits(j)$rev(j) = -Vmax;
LowerLimits(j)$exch(j) = 0;
UpperLimits(j) = Vmax;